#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
ELEC-E5500 Speech Processing -- Autumn 2020 Python Exercise 1:
Basics of speech processing and analysis in Python.

Recommended to use a virtual environment to have a clear management of the libraries used in the exercises.

Python version: 3.5 or higher

To make sure all the packages are up-to-date for the exercise, run the script Update_Packages_ex1.py.
"""
import os.path as path
import scipy.io.wavfile as wav
import scipy.signal as sig
import numpy as np
import ex1_windowing as win
import matplotlib.pyplot as pl


# 1.1. Read the audio file SX83.WAV and sampling rate
file_path = path.join('.','Sounds')
sound_file = path.join(file_path,'SX83.wav')
Fs,in_sig = None #Read audio file

# 1.2. Make sure the sampling rate is 16kHz, resample if necessary
Fs_target = 16000



## 1.3. Split the data sequence into windows.
# Implement windowing function in ex1_windowing.py
frame_length = np.int(np.around(0.025*Fs))# 25ms in samples
hop_size = np.int(np.around(0.0125*Fs))# 12.5 ms in samples (50% overlap)
window_types = ('rect','hann','cosine','hamming')
frame_matrix = win.ex1_windowing(in_sig, frame_length, hop_size, window_types[3])# Windowing


# 1.4. Visualization. Create a new figure with three subplots.
pl.figure(1)
## 1.4.1. Plot the whole signal into subplot 1. Denote x-axis as time in seconds and y-axis as Amplitude.
### Set appropriate strings to title, xlabel and ylabel
pl.subplot(3,1,1)


    
## 1.4.2. Plot a VOICED frame from frame_matrix into subplot 2. Denote x-axis as milliseconds.
### Set appropriate strings to title, xlabel and ylabel
pl.subplot(3,1,2)

    

## 1.4.3. Plot the magnitude spectrum of the same frame as in 1.4.2. into
## subplot 3. Denote x-axis as Hz, and y-axis as decibels.
### Set appropriate strings to title, xlabel and ylabel
pl.subplot(3,1,3)


    
pl.show(block=False)
## 1.4.4. Compute and plot the spectrogram of the whole signal into a new
## figure. Denote x-axis as frame number and y-axis as Frequency in Hz
### Set appropriate strings to title, xlabel and ylabel
pl.figure(2)



pl.show()
